// =============================================================================
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011 - DIGITEO - Cedric DELAMARRE
//
//  This file is distributed under the same license as the Scilab package.
// =============================================================================

stacksize('max');

function bench()

    lines(0);

    abs_path = get_absolute_file_path("gpuAdd.tst");
    fileName = abs_path + "benchData/add.h5";

    matSize = 0;
    n       = 60;
    step    = 100;

    computeTime = zeros(n,5);
    dataSize    = zeros(n,1);

    for i = 1:n,

        matSize = matSize + step;
        disp(matSize);
        tic();toc();
        b = rand(matSize,matSize);
        a = rand(matSize,matSize);
        gpu = zeros(matSize,matSize);
        cpu = zeros(matSize,matSize);
        dataSize(i,1) = length(a)/1000000;

        tic();
            da = gpuSetData(a);
            db = gpuSetData(b);
        computeTime(i,3) = toc();

        tic(); dgpu = gpuAdd(da,db);    computeTime(i,4) = toc();
        tic(); gpu  = gpuGetData(dgpu); computeTime(i,5) = toc();
        gpuFree(da);
        gpuFree(db);
        gpuFree(dgpu);

        computeTime(i,2) = computeTime(i,4) + computeTime(i,3) + computeTime(i,5);

        tic();cpu = a + b; computeTime(i,1) = toc();

    end

    saveMyBench(fileName,"Scilab - Matrix addition","Data Size (Million of elements)","Computation Time (seconds)",dataSize,computeTime,["Intel Xeon CPU E5410 @ 2.33GHz", "Nvidia GTX 560 Ti", "Data transfert CPU to GPU", "GPU Computation","Data transfert GPU to CPU"]);

endfunction

bench();
clear bench;
