// =============================================================================
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011 - DIGITEO - Cedric DELAMARRE
//
//  This file is distributed under the same license as the Scilab package.
// =============================================================================

stacksize('max');

function bench()

    lines(0);

    abs_path = get_absolute_file_path("gpuMult.tst");
    fileName = abs_path + "benchData/prod.h5";

    matSize = 0;
    n       = 10;
    step    = 100;

    computeTime = zeros(n,2);
    dataSize    = zeros(n,1);

    for i = 1:n,

        matSize = matSize + step;
        disp(matSize);
        tic();toc();
        b = rand(matSize,matSize);
        a = rand(matSize,matSize);
        gpu = zeros(matSize,matSize);
        cpu = zeros(matSize,matSize);
        dataSize(i,1) = length(a)/1000000;

        tic();cpu = a * b; computeTime(i,1) = toc();

        tic();d = gpuMult(a,b); gpu = gpuGetData(d); gpuFree(d); computeTime(i,2) = toc();

    end

    saveMyBench(fileName,"Scilab - Matrix multiplication","Data Size (Million of elements)","Computation Time (seconds)",dataSize,computeTime,["Intel Xeon CPU E5410 @ 2.33GHz", "Nvidia GTX 560 Ti"]);

endfunction

bench();
clear bench;
